/*	$Id: score.h,v 1.20 2017/06/07 17:26:35 hacki Exp $ */

/*
 * Copyright (c) 2017 Marcus Glocker <marcus@nazgul.ch>
 *
 * Permission to use, copy, modify, and distribute this software for any
 * purpose with or without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
 * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
 * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
 * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
 * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */

/*
 * Defines.
 */
#define SCORE_MAX		9990
#define USERNAME_MAXLEN		14
#define SCOREFILE_NAME		".spaceinvaders.scores"
#define SCOREFILE_SIZE		sizeof(struct score_file)
#define SCOREFILE_SIZE_LEGACY	4
#define HISCORE_LIST_MAX	10
#ifndef HISCORE_USER_MAX
#define HISCORE_USER_MAX	1
#endif

/*
 * Structures.
 */
struct score_file {
        char    username[USERNAME_MAXLEN+1];
        int     hiscore;
	int	timesec;
};

/*
 * Prototypes.h
 */
int	 score_file_verify(char *);
int	 score_file_read(char *, struct score_file *);
int	 score_file_read_legacy(char *, struct score_file *);
int	 score_file_write(char *, struct score_file *);
int	 score_create_hiscore_list(int, struct score_file *);
int	 score_cmp(const void *, const void *);
void	 score_print(void);
char	*score_get_username(void);
char	*score_get_filepath(void);
char	*score_convert_playtime(int);
#if !defined(__OpenBSD__) && \
    !defined(__NetBSD__)  && \
    !defined(__FreeBSD__) && \
    !defined(__APPLE__)   && \
    !defined(__sun)
size_t	 strlcpy(char *, const char *, size_t);
#endif
